var BASE_URL = 'http://www.evite.com';
var req;
var MAX_EVENTS_DISP = 2;
var MAX_TITLE_SIZE = 18;
var MY_EVITE_URL = BASE_URL + '/pages/myevite/myEvite.jsp?src=dash';
var XML_MY_EVITE_URL = BASE_URL + '/app/xml/evite/myEvite.do';
var XML_USER_AUTH_URL = BASE_URL + '/app/xml/evite/userAuth.do';

var INVALID_EMAIL_TEXT = 'Invalid email or password';
var VERIFY_EMAIL_TEXT = 'Verifying email and password';



function checkToSubmitLoginForm(){
 	switch (event.keyCode) {
    	case 13: // return
        	verifyUserAuth();
            break;
        case 3:  // enter
        case 9:  // tab
                       
    }
}

function cleanUP(){
	if(window.widget){
		widget.setPreferenceForKey(null, 'userID');
	}
}

function displayStatusText(statusText){
	var statusContent = document.getElementById("statusText");
	if(statusText != null){
		if(statusText.length > 0){
			statusText = 'Status: ' + statusText;
			statusContent.innerHTML=statusText;
		}
	}	
}

function hideStatusText(statusText){
	var statusContent = document.getElementById("statusText");
	statusContent.innerHTML='';
}

function getFormattedDate(unformattedDate, timeType){
	var formattedDate = '';
	var sMonth = unformattedDate.substring(4,6);
	var sDay = unformattedDate.substring(6,8);
	var sYear = unformattedDate.substring(0,4);
	
	
	
	if(timeType!='tbd'){
		if(sMonth < 10){
			sMonth = sMonth.substring(1,2);
		}
	
		if(sDay.substring(0,1) == '0'){
			sDay = sDay.substring(1,2);
		}	
		
		formattedDate = sMonth + '/' + sDay + ' ';
	} else {
		formattedDate = 'TBD';
	}
	
	
	return formattedDate;
}

function getFormattedTime(unformattedTime){
	var sHour = unformattedTime.substring(0,2);
	var sMinute = unformattedTime.substring(2,4);
	var timeAppender = "am";
	if(sHour > 12){
	   sHour = sHour - 12 + '';
	   
	   if(sHour.substring(0,1) == '0'){
	      sHour = sHour.substring(1,2);
	   }
	   
	   timeAppender = "pm";
	} else if (sHour == 12){
	   timeAppender = "pm";
	}
	
	sHour + ':' + sMinute + timeAppender;
}

function loadEventsTimer(){

	var userID = '';
	if(window.widget){
		userID = widget.preferenceForKey('userID');
	}
	
	if(userID == null){
		userID = '';
	}
	
	loadMyEviteXMLDoc(userID);


}



function loadMyEviteXMLDoc(userID) {
	var url = XML_MY_EVITE_URL + '?userID=' + userID + '&src=dash&rndm=' + getRandomNumber();
	
    // branch for native XMLHttpRequest object
    if (window.XMLHttpRequest) {
        req = new XMLHttpRequest();
        req.onreadystatechange = processMyEviteReqChange;
        req.open("GET", url, true);
        req.send(null);
    }
}


function processMyEviteXMLDocument(reqObject){
	var eviteContent = document.getElementById("eviteText");
	var xmlDocument = reqObject.responseXML;
	var output = '';
	var eviteEvents = xmlDocument.getElementsByTagName("event");
	var eventRSVPs = 0;
	var eventMessages = 0;
	var eventTitle = '';
	var eventURL = '';
	var eventDate = '';
	var eventTime = '';
	var timeType = '';
	var eventRSVPHTML = '';
	
	var formatEventDate = '';
	var eventLength = eviteEvents.length;
	var dispMoreEvents = false;
	var dynamicText = getDynamicText(xmlDocument);
	

	if(eventLength > MAX_EVENTS_DISP){
		dispMoreEvents = true;
	}
	
	if(eventLength == 0){
		output += '<div style="height:43;"><p style="position: absolute; _top: -50%;"><i>No upcoming events</i></p></div>';
		output += '<div style="height:43;"><p style="position: absolute; _top: -50%;">' + dynamicText + '</p></div>';
		
	} else if (eventLength == 1){
		eventRSVPs = getElementText("", "newRSVPs", eviteEvents[0], 0);
		eventTitle = getElementText("", "title", eviteEvents[0], 0);
		timeType = getElementText("", "timeType", eviteEvents[0], 0);
		eventMessages = getElementText("", "eventMessages", eviteEvents[0], 0);
		
		
		if(eventTitle.length > MAX_TITLE_SIZE){
			eventTitle = eventTitle.substring(0,MAX_TITLE_SIZE) + '...';
		}
		
		eventURL = getElementText("", "url", eviteEvents[0], 0);
		
		eventDate = getElementText("", "eventDate", eviteEvents[0], 0);
		formatEventDate = getFormattedDate(eventDate, timeType);
		eventRSVPHTML = '<span class="text9">';
		if(eventRSVPs > 0){
		   eventRSVPHTML += eventRSVPs + ' new RSVP(s) ';
		}
		if(eventMessages > 0){
			eventRSVPHTML += eventMessages + ' msg(s)';
		}
		eventRSVPHTML += '</span>';
		
		output += '<div style="float: left; height:43px;"><p style="position: absolute; _top: -50%; line-height:20px;" class="text9">' + formatEventDate + '</p></div>';
		output += '<div id="event"><p style="position: absolute; _top: -50%;"><a href="javascript:widget.openURL(\'' + eventURL + '\')">' + eventTitle + '</a><br />' + eventRSVPHTML + '</p></div>';		
		output += '<div style="clear:both; height:43px;"><p style="position: absolute; _top: -50%;">' + dynamicText + '</p></div>';
		
		
	} else if (eventLength >= MAX_EVENTS_DISP){
		for (var i = 0; i < MAX_EVENTS_DISP; i++) {
			eventRSVPs = getElementText("", "newRSVPs", eviteEvents[i], 0);
			eventMessages = getElementText("", "eventMessages", eviteEvents[i], 0);
			eventTitle = getElementText("", "title", eviteEvents[i], 0);
			timeType = getElementText("", "timeType", eviteEvents[i], 0);
			
			if(eventTitle.length > MAX_TITLE_SIZE){
				eventTitle = eventTitle.substring(0,MAX_TITLE_SIZE) + '...';
			}
			
			eventURL = getElementText("", "url", eviteEvents[i], 0);
		
	alert('Event URL = ' + eventURL);	
			eventDate = getElementText("", "eventDate", eviteEvents[i], 0);
			formatEventDate = getFormattedDate(eventDate, timeType);
		
			eventRSVPHTML = '<span class="text9">';
			if(eventRSVPs > 0){
			   	eventRSVPHTML += eventRSVPs + ' new RSVP(s) ';
			}
			if(eventMessages > 0){
				eventRSVPHTML += eventMessages + ' msg(s)';
			}
			eventRSVPHTML += '</span>';
			
  			output += '<div style="float: left; height:43px;"><p style="position: absolute; _top: -50%; line-height:20px;" class="text9">' + formatEventDate + '</p></div>';
			output += '<div id="event"><p style="position: absolute; _top: -50%;"><a href="javascript:widget.openURL(\'' + eventURL + '\')">' + eventTitle + '</a><br />' + eventRSVPHTML + '</div>';		
			output += '<div style="clear:both;"></div>';

		}
	}
	
	if(dispMoreEvents == true){
		setFrontStatusMessage('<a href="javascript:widget.openURL(\'' + MY_EVITE_URL + '\');">view all invites</a>');
	//	var value = '<img src="images/arrow.png" width="11" height="9">';
	//	var eviteFrontStatus = document.getElementById("eviteFrontStatus");
	//	eviteFrontStatus.innerHTML = value;
	}
   
    eviteContent.innerHTML=output;
    
}

function processRandomTemplate(reqObject){
	var randomTemplate = document.getElementById("randomTemplate");
	
	var xmlDocument = reqObject.responseXML;
	var output = '';
	var templateName = '';
	var imgLoc = '';
	var createURL = '';
	if(xmlDocument != null){
		var invitationsElement = findChild(xmlDocument, 'invitations');
		if(invitationsElement != null){
			var templateElement = findChild (invitationsElement, 'template');
			if(templateElement != null){
				templateName = getElementText("", "name", templateElement, 0);
				imgLoc = getElementText("", "imgLoc", templateElement, 0);
				createURL = getElementText("", "createURL", templateElement, 0);
			}
		}
	} 
	
//	var eviteEvents = xmlDocument.getElementsByTagName("event");
//	eventRSVPs = getElementText("", "newRSVPs", eviteEvents[i], 0);
			
	output += '<a href="javascript:widget.openURL(\'' + createURL + '\');" style="color:#47852e;"><img src="' + imgLoc + '" height="60" width="80">';
    output += '<br /><!--MAXIMUM thumbnail CHARACTERS 11-->' + templateName + '</a>';
 //   output += '<br /><img src="images/t.png" width="67" height="1" border="0">';
 //   output += '<img id="prefsFlipper" src="images/flipper.png" width="11" height="11" border="0" onclick="showPrefs()">';
    
    randomTemplate.innerHTML=output;
    
    
}

function getDynamicText(xmlDocument){

	var dynamicText = '';
	if(xmlDocument != null){
		var invitationsElement = findChild(xmlDocument, 'invitations');
		if(invitationsElement != null){
			var summaryElement = findChild (invitationsElement, 'summary');
			if(summaryElement != null){
				dynamicText = getElementText("", "dynamicText", summaryElement, 0);
			}
		}
	} 
	return dynamicText;
}


function validUser(reqObject){
	var validUser = null;
	var xmlDocument = reqObject.responseXML;
	if(xmlDocument != null){
		var invitationsElement = findChild(xmlDocument, 'invitations');
		if(invitationsElement != null){
			var headerElement = findChild (invitationsElement, 'header');
			if(headerElement != null){
				var responseElement = findChild (headerElement, "response");	
				if(responseElement != null){
					var responseElementValue = responseElement.firstChild.data;
					if(responseElementValue == '1'){
						validUser = true;
					} else {
						validUser = false;
					}
				}
			}
		}
	}
	return validUser;
}


function processMyEviteReqChange() {
    // only if req shows "loaded"
    if (req.readyState == 4) {
    	processRandomTemplate(req);
		setFrontStatusMessage('');
    	var isValidUser = validUser(req);
    	
    	if(isValidUser != null){
    		if(isValidUser == true){
    			processMyEviteXMLDocument(req);
      		} else {
				setFrontStatusMessage('Not Logged In');
        	}
        } else {
        	setFrontStatusMessage('Not connected');
        }
    }
}

function loadUserAuthXMLDoc(email,pass) {

	var url = XML_USER_AUTH_URL + '?email='+email+'&pass='+pass + '&src=dash&rndm=' + getRandomNumber();
	
	// branch for native XMLHttpRequest object
    if (window.XMLHttpRequest) {
        req = new XMLHttpRequest();
        req.onreadystatechange = processUserAuthReqChange;
        if(req !=null){
			req.open("GET", url, true);
			req.send(null);
        }
    }
    
}


function processUserAuthReqChange() {
    // only if req shows "loaded"
    if (req.readyState == 4) {
    	processUserAuthXMLDocument(req);
    	userID = widget.preferenceForKey('userID');
		if(userID.length == 20){
			hidePrefs();
			loadMyEviteXMLDoc(userID);
		} else {
			displayStatusText(INVALID_EMAIL_TEXT);
		}
    }
}

function processUserAuthXMLDocument(reqObject){

	cleanUP();
	var userID = '';
	var xmlDocument = reqObject.responseXML;
	if(xmlDocument != null){
		var eviteUserElement = findChild(xmlDocument, 'EviteUserInfo');
		if(eviteUserElement != null){
			var eviteAuthElement = findChild (eviteUserElement, "eviteAuth");
			if(eviteAuthElement != null){
				var validUserElement = findChild (eviteAuthElement, "validUser");
				if(validUserElement != null){
					var validUser = validUserElement.firstChild.data;
					if(validUser == '1'){
						var userIDElement = findChild (eviteAuthElement, "userID");
						userID = userIDElement.firstChild.data;
					}
				}
			}
		}
	}
	
	if(window.widget){
		widget.setPreferenceForKey(userID, 'userID');
	}
	
}

function verifyUserAuth(){

	cleanUP();
	displayStatusText(VERIFY_EMAIL_TEXT);
	
	var email = document.getElementById('email').value;
	var pass = document.getElementById('pass').value;
	
	loadUserAuthXMLDoc(email, pass);
	
}

function getRandomNumber(){
	var randomNum  = (Math.round((Math.random()*100)+1));
	return randomNum;
}

function setFrontStatusMessage(statusMessage) {
	value = '';
	if(statusMessage.length > 0){
		value += '<img src="images/arrow.png" width="11" height="9">'
		value += statusMessage;
	} else {
		value = '&nbsp;';
	}
	var eviteFrontStatus = document.getElementById("eviteFrontStatus");
	eviteFrontStatus.innerHTML = value;

    
}
